/* CharBox.c generated by valac 0.56.14, the Vala compiler
 * generated from CharBox.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <adwaita.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CHAR_BOX (char_box_get_type ())
#define CHAR_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHAR_BOX, CharBox))
#define CHAR_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHAR_BOX, CharBoxClass))
#define IS_CHAR_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHAR_BOX))
#define IS_CHAR_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHAR_BOX))
#define CHAR_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHAR_BOX, CharBoxClass))

typedef struct _CharBox CharBox;
typedef struct _CharBoxClass CharBoxClass;
typedef struct _CharBoxPrivate CharBoxPrivate;
enum  {
	CHAR_BOX_0_PROPERTY,
	CHAR_BOX_LETTER_PROPERTY,
	CHAR_BOX_HIGHLIGHT_PROPERTY,
	CHAR_BOX_NUM_PROPERTIES
};
static GParamSpec* char_box_properties[CHAR_BOX_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	CHAR_BOX_CLICKED_SIGNAL,
	CHAR_BOX_NUM_SIGNALS
};
static guint char_box_signals[CHAR_BOX_NUM_SIGNALS] = {0};

struct _CharBox {
	AdwBin parent_instance;
	CharBoxPrivate * priv;
};

struct _CharBoxClass {
	AdwBinClass parent_class;
};

struct _CharBoxPrivate {
	gchar* _letter;
	GtkStateFlags _highlight;
	GtkButton* button;
};

static gint CharBox_private_offset;
static gpointer char_box_parent_class = NULL;

VALA_EXTERN GType char_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CharBox, g_object_unref)
VALA_EXTERN CharBox* char_box_new (const gchar* letter);
VALA_EXTERN CharBox* char_box_construct (GType object_type,
                             const gchar* letter);
static void char_box_on_button_clicked (CharBox* self);
static void _char_box_on_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
VALA_EXTERN const gchar* char_box_get_letter (CharBox* self);
static void char_box_set_letter (CharBox* self,
                          const gchar* value);
VALA_EXTERN GtkStateFlags char_box_get_highlight (CharBox* self);
VALA_EXTERN void char_box_set_highlight (CharBox* self,
                             GtkStateFlags value);
static void char_box_finalize (GObject * obj);
static GType char_box_get_type_once (void);
static void _vala_char_box_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_char_box_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);

static inline gpointer
char_box_get_instance_private (CharBox* self)
{
	return G_STRUCT_MEMBER_P (self, CharBox_private_offset);
}

CharBox*
char_box_construct (GType object_type,
                    const gchar* letter)
{
	CharBox * self = NULL;
#line 25 "../gmult/CharBox.vala"
	g_return_val_if_fail (letter != NULL, NULL);
#line 27 "../gmult/CharBox.vala"
	self = (CharBox*) g_object_new (object_type, "letter", letter, NULL);
#line 25 "../gmult/CharBox.vala"
	return self;
#line 118 "CharBox.c"
}

CharBox*
char_box_new (const gchar* letter)
{
#line 25 "../gmult/CharBox.vala"
	return char_box_construct (TYPE_CHAR_BOX, letter);
#line 126 "CharBox.c"
}

static void
char_box_on_button_clicked (CharBox* self)
{
#line 34 "../gmult/CharBox.vala"
	g_return_if_fail (self != NULL);
#line 36 "../gmult/CharBox.vala"
	g_signal_emit (self, char_box_signals[CHAR_BOX_CLICKED_SIGNAL], 0);
#line 136 "CharBox.c"
}

static void
_char_box_on_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 10 "../gmult/CharBox.vala"
	char_box_on_button_clicked ((CharBox*) self);
#line 145 "CharBox.c"
}

const gchar*
char_box_get_letter (CharBox* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 12 "../gmult/CharBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 12 "../gmult/CharBox.vala"
	_tmp0_ = self->priv->_letter;
#line 12 "../gmult/CharBox.vala"
	result = _tmp0_;
#line 12 "../gmult/CharBox.vala"
	return result;
#line 161 "CharBox.c"
}

static void
char_box_set_letter (CharBox* self,
                     const gchar* value)
{
	gchar* old_value;
#line 12 "../gmult/CharBox.vala"
	g_return_if_fail (self != NULL);
#line 12 "../gmult/CharBox.vala"
	old_value = char_box_get_letter (self);
#line 12 "../gmult/CharBox.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 175 "CharBox.c"
		gchar* _tmp0_;
#line 12 "../gmult/CharBox.vala"
		_tmp0_ = g_strdup (value);
#line 12 "../gmult/CharBox.vala"
		_g_free0 (self->priv->_letter);
#line 12 "../gmult/CharBox.vala"
		self->priv->_letter = _tmp0_;
#line 12 "../gmult/CharBox.vala"
		g_object_notify_by_pspec ((GObject *) self, char_box_properties[CHAR_BOX_LETTER_PROPERTY]);
#line 185 "CharBox.c"
	}
}

GtkStateFlags
char_box_get_highlight (CharBox* self)
{
	GtkStateFlags result;
#line 17 "../gmult/CharBox.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 17 "../gmult/CharBox.vala"
	result = self->priv->_highlight;
#line 17 "../gmult/CharBox.vala"
	return result;
#line 199 "CharBox.c"
}

void
char_box_set_highlight (CharBox* self,
                        GtkStateFlags value)
{
	GtkButton* _tmp0_;
#line 18 "../gmult/CharBox.vala"
	g_return_if_fail (self != NULL);
#line 19 "../gmult/CharBox.vala"
	self->priv->_highlight = value;
#line 20 "../gmult/CharBox.vala"
	_tmp0_ = self->priv->button;
#line 20 "../gmult/CharBox.vala"
	gtk_widget_set_state_flags ((GtkWidget*) _tmp0_, value, TRUE);
#line 18 "../gmult/CharBox.vala"
	g_object_notify_by_pspec ((GObject *) self, char_box_properties[CHAR_BOX_HIGHLIGHT_PROPERTY]);
#line 217 "CharBox.c"
}

static void
char_box_class_init (CharBoxClass * klass,
                     gpointer klass_data)
{
#line 10 "../gmult/CharBox.vala"
	char_box_parent_class = g_type_class_peek_parent (klass);
#line 10 "../gmult/CharBox.vala"
	g_type_class_adjust_private_offset (klass, &CharBox_private_offset);
#line 10 "../gmult/CharBox.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_char_box_get_property;
#line 10 "../gmult/CharBox.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_char_box_set_property;
#line 10 "../gmult/CharBox.vala"
	G_OBJECT_CLASS (klass)->finalize = char_box_finalize;
#line 10 "../gmult/CharBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHAR_BOX_LETTER_PROPERTY, char_box_properties[CHAR_BOX_LETTER_PROPERTY] = g_param_spec_string ("letter", "letter", "letter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 10 "../gmult/CharBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHAR_BOX_HIGHLIGHT_PROPERTY, char_box_properties[CHAR_BOX_HIGHLIGHT_PROPERTY] = g_param_spec_flags ("highlight", "highlight", "highlight", gtk_state_flags_get_type (), 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../gmult/CharBox.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/app/drey/MultiplicationPuzzle/CharBox.ui");
#line 10 "../gmult/CharBox.vala"
	char_box_signals[CHAR_BOX_CLICKED_SIGNAL] = g_signal_new ("clicked", TYPE_CHAR_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 10 "../gmult/CharBox.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button", FALSE, CharBox_private_offset + G_STRUCT_OFFSET (CharBoxPrivate, button));
#line 10 "../gmult/CharBox.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_button_clicked", G_CALLBACK(_char_box_on_button_clicked_gtk_button_clicked));
#line 246 "CharBox.c"
}

static void
char_box_instance_init (CharBox * self,
                        gpointer klass)
{
	gchar* _tmp0_;
#line 10 "../gmult/CharBox.vala"
	self->priv = char_box_get_instance_private (self);
#line 12 "../gmult/CharBox.vala"
	_tmp0_ = g_strdup ("?");
#line 12 "../gmult/CharBox.vala"
	self->priv->_letter = _tmp0_;
#line 15 "../gmult/CharBox.vala"
	self->priv->_highlight = GTK_STATE_FLAG_NORMAL;
#line 10 "../gmult/CharBox.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 264 "CharBox.c"
}

static void
char_box_finalize (GObject * obj)
{
	CharBox * self;
#line 10 "../gmult/CharBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHAR_BOX, CharBox);
#line 12 "../gmult/CharBox.vala"
	_g_free0 (self->priv->_letter);
#line 10 "../gmult/CharBox.vala"
	G_OBJECT_CLASS (char_box_parent_class)->finalize (obj);
#line 277 "CharBox.c"
}

 G_GNUC_NO_INLINE static GType
char_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CharBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) char_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CharBox), 0, (GInstanceInitFunc) char_box_instance_init, NULL };
	GType char_box_type_id;
	char_box_type_id = g_type_register_static (adw_bin_get_type (), "CharBox", &g_define_type_info, 0);
	CharBox_private_offset = g_type_add_instance_private (char_box_type_id, sizeof (CharBoxPrivate));
	return char_box_type_id;
}

GType
char_box_get_type (void)
{
	static gsize char_box_type_id__once = 0;
	if (g_once_init_enter (&char_box_type_id__once)) {
		GType char_box_type_id;
		char_box_type_id = char_box_get_type_once ();
		g_once_init_leave (&char_box_type_id__once, char_box_type_id);
	}
	return char_box_type_id__once;
}

static void
_vala_char_box_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	CharBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHAR_BOX, CharBox);
#line 10 "../gmult/CharBox.vala"
	switch (property_id) {
#line 10 "../gmult/CharBox.vala"
		case CHAR_BOX_LETTER_PROPERTY:
#line 10 "../gmult/CharBox.vala"
		g_value_set_string (value, char_box_get_letter (self));
#line 10 "../gmult/CharBox.vala"
		break;
#line 10 "../gmult/CharBox.vala"
		case CHAR_BOX_HIGHLIGHT_PROPERTY:
#line 10 "../gmult/CharBox.vala"
		g_value_set_flags (value, char_box_get_highlight (self));
#line 10 "../gmult/CharBox.vala"
		break;
#line 324 "CharBox.c"
		default:
#line 10 "../gmult/CharBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../gmult/CharBox.vala"
		break;
#line 330 "CharBox.c"
	}
}

static void
_vala_char_box_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	CharBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHAR_BOX, CharBox);
#line 10 "../gmult/CharBox.vala"
	switch (property_id) {
#line 10 "../gmult/CharBox.vala"
		case CHAR_BOX_LETTER_PROPERTY:
#line 10 "../gmult/CharBox.vala"
		char_box_set_letter (self, g_value_get_string (value));
#line 10 "../gmult/CharBox.vala"
		break;
#line 10 "../gmult/CharBox.vala"
		case CHAR_BOX_HIGHLIGHT_PROPERTY:
#line 10 "../gmult/CharBox.vala"
		char_box_set_highlight (self, g_value_get_flags (value));
#line 10 "../gmult/CharBox.vala"
		break;
#line 356 "CharBox.c"
		default:
#line 10 "../gmult/CharBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../gmult/CharBox.vala"
		break;
#line 362 "CharBox.c"
	}
}

